// Generated by CoffeeScript 1.8.0
(function() {
  var App, MojioClient, assert, config, mojio_client, should, testObject, testdata;

  MojioClient = require('../lib/nodejs/MojioClient');

  App = require('../lib/models/App');

  config = require('./config/mojio-config.coffee');

  mojio_client = new MojioClient(config);

  assert = require('assert');

  testdata = require('./data/mojio-test-data');

  should = require('should');

  testObject = null;

  describe('App', function() {
    before(function(done) {
      return mojio_client.login(testdata.username, testdata.password, function(error, result) {
        (error === null).should.be["true"];
        return done();
      });
    });
    it('can get Apps from Model', function(done) {
      var app;
      app = new App({});
      app.authorization(mojio_client);
      return app.get({}, function(error, result) {
        var instance, _i, _len, _ref;
        (error === null).should.be["true"];
        mojio_client.should.be.an.instanceOf(MojioClient);
        result.Objects.should.be.an.instanceOf(Array);
        if ((result.Objects != null) && result.Objects instanceof Array) {
          _ref = result.Objects;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            instance = _ref[_i];
            instance.should.be.an.instanceOf(App);
          }
          testObject = instance;
        } else {
          result.should.be.an.instanceOf(App);
          testObject = result;
        }
        return done();
      });
    });
    it('can get Apps', function(done) {
      return mojio_client.get(App, {}, function(error, result) {
        var instance, _i, _len, _ref;
        (error === null).should.be["true"];
        mojio_client.should.be.an.instanceOf(MojioClient);
        result.Objects.should.be.an.instanceOf(Array);
        _ref = result.Objects;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          instance = _ref[_i];
          instance.should.be.an.instanceOf(App);
        }
        return done();
      });
    });
    it('can create, find, save, and delete App', function(done) {
      var app;
      app = new App().mock();
      return mojio_client.post(app, function(error, result) {
        (error === null).should.be["true"];
        app = new App(result);
        return mojio_client.get(App, app.id(), function(error, result) {
          (error === null).should.be["true"];
          mojio_client.should.be.an.instanceOf(MojioClient);
          result.should.be.an.instanceOf(App);
          return mojio_client.put(result, function(error, result) {
            (error === null).should.be["true"];
            result.should.be.an.instanceOf(Object);
            app = new App(result);
            return mojio_client["delete"](app, function(error, result) {
              (error === null).should.be["true"];
              (result.result === "ok").should.be["true"];
              return done();
            });
          });
        });
      });
    });
    return it('can create, save, and delete App from model', function(done) {
      var app;
      app = new App().mock();
      app.authorization(mojio_client);
      app._id = null;
      return app.post(function(error, result) {
        (error === null).should.be["true"];
        result.should.be.an.instanceOf(Object);
        app = new App(result);
        app.authorization(mojio_client);
        return app.get(app.id(), function(error, result) {
          result.should.be.an.instanceOf(App);
          app = new App(result);
          app.authorization(mojio_client);
          return app.put(function(error, result) {
            (error === null).should.be["true"];
            result.should.be.an.instanceOf(Object);
            app = new App(result);
            app.authorization(mojio_client);
            return app["delete"](function(error, result) {
              (error === null).should.be["true"];
              (result.result === "ok").should.be["true"];
              return done();
            });
          });
        });
      });
    });
  });

}).call(this);

//# sourceMappingURL=App_test.js.map
